All patches and comments are welcome. Please squash your changes to logical
commits before using git-format-patch and git-send-email to
patches@git.madduck.net.
If you'd read over the Git project's submission guidelines and adhered to them,
I'd be especially grateful.
3 [ -n "$VCSH_DEBUG" ] && set -x
4 [ -z "$XDG_CONFIG_HOME" ] && XDG_CONFIG_HOME="$HOME/.config"
5 [ -z "$VCSH_BASE" ] && VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
11 echo "usage: $SELF <args>
14 [<repo>] Clone from an existing repository
15 help Display this help text
16 delete Delete an existing repository
17 init <repo> Initialize a new repository
20 <command> Use this repository
23 <repo> Seed .gitignore.d/<repo> from git ls-files
25 <repo> <git command> Special command that allows you to run git commands
26 directly without having to type so much ;)" >&2
27 # use <repo> Use this repository
29 # exit Exit vcsh mode" >&2
33 [ -n "$VCSH_DEBUG" ] && echo "$SELF: debug: $@"
37 if [ -n "$VCSH_DEBUG" ] || [ -n "$VCSH_VERBOSE" ]; then echo "$SELF: verbose: $@"; fi
42 if [ ! -d "$GIT_DIR" ]; then
43 echo E: no repository found for "$VCSH_REPO_NAME" >&2
47 export GIT_WORK_TREE="$(git config --get core.worktree)"
48 export VCSH_DIRECTORY="$VCSH_REPO_NAME"
53 verbose "init() begin"
55 echo "$SELF: fatal: $GIT_DIR exists" &&
57 export GIT_WORK_TREE="$HOME"
58 mkdir -p "$GIT_WORK_TREE"
59 cd "$GIT_WORK_TREE" ||
60 (echo "$SELF: fatal: could not enter $GIT_WORK_TREE" &&
64 git config core.worktree "$GIT_WORK_TREE"
65 git config core.excludesfile ".gitignore.d/$REPO_NAME"
66 touch "$HOME/.gitignore.d/$REPO_NAME"
67 git add "$HOME/.gitignore.d/$REPO_NAME"
78 if [ "$1" = 'clone' ]; then
82 [ -z "$VCSH_REPO_NAME" ] && VCSH_REPO_NAME=$(basename "$GIT_REMOTE" .git)
84 export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
85 elif [ "$1" = 'delete' ] ||
88 [ "$1" = 'seed-gitignore' ]; then
89 [ -z $2 ] && echo "$SELF $1: error: please specify repository to work on" && return 1
90 [ -z $3 ] && echo "$SELF $1 $2: error: please specify a command" && return 1
91 export VCSH_COMMAND="$1"
92 export VCSH_REPO_NAME="$2"
93 export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
95 export VCSH_EXTERNAL_COMMAND="$*"
96 elif [ "$1" = 'help' ] ||
97 [ "$1" = 'list' ]; then
98 export VCSH_COMMAND="$1"
100 [ -z $1 ] && help && return 0
101 export VCSH_COMMAND='run'
102 export VCSH_REPO_NAME="$1"
103 export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
104 [ -d $GIT_DIR ] || (help && return 1) || return 0
106 export VCSH_EXTERNAL_COMMAND="git $*"
110 for check_directory in "$VCSH_BASE" "$HOME/.gitignore.d"
112 if [ ! -d "$check_directory" ]; then
113 if [ -e "$check_directory" ]; then
114 echo "$SELF: error: $check_directory exists but is not a directory" >&2
117 echo "$SELF: info: attempting to create $check_directory"
118 mkdir -p "$check_directory" || (echo "$SELF: error: could not create $check_directory" >&2; exit 2)
124 if [ "$VCSH_COMMAND" = 'clone' ]; then
125 verbose "clone begin"
127 git remote add origin "$GIT_REMOTE"
128 git config branch.master.remote origin
129 git config branch.master.merge refs/heads/master
131 for object in $(git ls-tree -r origin/master | awk '{print $4}'); do
133 echo "$SELF: error: $object exists." &&
136 [ "$VCSH_CONFLICT" = '1' ] &&
137 echo "$SELF: fatal: will stop after fetching and not try to merge!\n" &&
138 echo " Once this situation has been resolved, run 'vcsh run <foo> git pull' to finish cloning.\n" &&
140 git merge origin/master
144 elif [ "$VCSH_COMMAND" = 'help' ] || [ "$#" -eq 0 ]; then
147 elif [ "$VCSH_COMMAND" = 'delete' ]; then
148 verbose "delete begin"
152 echo "$SELF: info: This operation WILL DETROY DATA!"
153 files=$(git ls-files)
154 echo "These files will be deleted:
158 AGAIN, THIS WILL DELETE YOUR DATA!
159 To continue, type \"Yes, do as I say\""
161 [ "x$answer" = "xYes, do as I say" ] || exit
162 for file in $files; do
163 rm -f $file || echo "$SELF: info: could not delete '$file', continuing with deletion"
165 rm -rf "$GIT_DIR" || echo "$SELF: info: could not delete '$GIT_DIR'"
169 #elif [ "$VCSH_COMMAND" = 'exit' ]; then
170 # verbose "exit begin"
171 # if [ -n "$ZSH_VERSION" ] && [ "$VCSH_NO_IGNORE_EOF" = '1' ]; then
172 # unset VCSH_NO_IGNORE_EOF
173 # setopt NO_IGNORE_EOF
176 # [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
180 elif [ "$VCSH_COMMAND" = 'init' ]; then
186 elif [ "$VCSH_COMMAND" = 'list' ]; then
188 for i in "$VCSH_BASE"/*.git; do
189 echo $(basename "$i" .git)
193 elif [ "$VCSH_COMMAND" = 'run' ]; then
196 $VCSH_EXTERNAL_COMMAND
200 elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
201 verbose "seed-gitignore begin"
203 # Switching directory as this has to be executed from $HOME to be of any use.
204 # Going back into old directory at the end in case `vcsh use` is reactivated.
207 git config core.excludesfile ".gitignore.d/$VCSH_REPO_NAME"
208 gitignores=$(for file in $(git ls-files); do
210 echo $file; new="${file%/*}"
211 [ "$file" = "$new" ] && break
214 done | sort -u | sed 's/^/!/')
215 tempfile=$(mktemp) ||
216 (echo "$SELF: fatal: could not create tempfile" && exit 1)
217 echo '*' > "$tempfile"
218 for gitignore in $gitignores; do
219 echo "$gitignore" >> "$tempfile"
221 diff -N "$tempfile" "$HOME/.gitignore.d/$2" > /dev/null &&
224 if [ -e "$HOME/.gitignore.d/$2" ]; then
225 echo "$SELF: info: $HOME/.gitignore.d/$2 differs from new data, moving it to $HOME/.gitignore.d/$2.bak"
226 mv -f "$HOME/.gitignore.d/$2" "$HOME/.gitignore.d/$2.bak" ||
227 (echo "$SELF: fatal: could not move $HOME/.gitignore.d/$2 to $HOME/.gitignore.d/$2.bak" && exit 1)
229 mv -f "$tempfile" "$HOME/.gitignore.d/$2" ||
230 (echo "$SELF: fatal: could not move $tempfile to $HOME/.gitignore.d/$2" && exit 1)
232 verbose "seed-gitignore end"
234 #elif [ "$VCSH_COMMAND" = 'use' ]; then
235 # verbose "use begin"
236 # if [ -n "$ZSH_VERSION" ]; then
237 # if [ -o NO_IGNORE_EOF ]; then
238 # export VCSH_NO_IGNORE_EOF=1
246 # bindkey '^d' 'vcsh_exit'
249 # [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
253 verbose "defaulting to calling help()"
255 echo "$SELF: fatal: You should never reach this code. File a bug, please."